def findBestSum(arr):
	n = len(arr)
	answer = [0 for i in range(n)]
	taken = [False for i in range(n)]

	if arr[0] * arr[1] > 0:
		answer[1] = arr[0] * arr[1]
		taken[1] = True

	for i in range(2,n):
		cand = arr[i] * arr[i - 1] + answer[i - 2]
		if cand > answer[i - 1]:
			answer[i] = cand
			taken[i] = True
		else:
			answer[i] = answer[i - 1]

	sol = []
	pos = n - 1

	while pos > 0:
		if taken[pos]:
			sol.append(pos)
			pos -= 2
		else:
			pos -= 1

	return answer[n - 1], sol[::-1]

def testAndPrint(arr):
	ans, sol = findBestSum(arr)
	print(ans)

	pairs = [ (i - 1, i) for i in sol ]
	nums = [ (arr[i - 1], arr[i]) for i in sol]

	print(pairs)
	print(nums)

example = [ -5, 7, 4, -2, -2, -8, 7, -5, 4, 2 ]
testAndPrint(example)

zeroExample = [ 4, -18, 11, -15, 9, -20, 11, -5, 17, -13 ]
testAndPrint(zeroExample)

naturalExample = [ 1, 2, 3, 4, 5, 6, 7, 8, 9 ]
testAndPrint(naturalExample)